/*
DynamicArrayBigOAnswers.java

RULES:

	1. Replace all tags "YOURANSWER" below with your big-o guess for the given method

	2. The method name pattern in this class is:

		Given a method in this class: "size_BigO"
		Then the associated method in DynamicArray: "size"

	3. Do Big-O analysis for the subject method (e.g. like "size" in previous step)

	4. Replace "YOURANSWER" with your best big-o analysis guess (either "1" or "n")

	5. Problems have been done for you to help you get started. See methods in this file:

		size_BigO
		isEmpty_BigO
		subList_BigO

	6. You may IGNORE "grow" and "shrink". In other words, do NOT consider them
	in your big-o analysis.

	7. Assume worst-case (except for "grow" and "shrink" which we ignore).
	Worst case means e.g. for a linear search or find, that means
	the match would be in the last list element.

	8. You do NOT need to add comments to your methods. You only need to provide
	a big-o guess (in other words, replace "YOURANSWER" with either "1" or "n").

*/

public class DynamicArrayBigOAnswers {

	//-------------------- Basic Statistics ---------------------

	public String size_BigO() {
		/* Your algorithm for "size" should produce logic that
		has a Big-O "O(1)" performance level. I.e. the algorithm
		work (effort) should be constant (unchanged) as structure size grows
		to a very large size. For "O(1)", we answer "1" as shown below
		in this method (completed for you) */
		return "1";
	}

	public String isEmpty_BigO() {
		/* Your "isEmpty" algorithm should also produce logic so that
		algorithm work (effort) does not change as structure size grows
		to a very large size -- i.e. a Big-O level of "O(1)". Like the
		previous method, we again answer "1" as shown below in this
		method (completed for you) */
		return "1";
	}

	//--------------------- Accessing ---------------------

	public String get_BigO(int index) {
		return "YOURANSWER";
	}

	public String subList_BigO(int start, int stop) {
		/* Your algorithm for "subList" should produce logic that
		has a Big-O "O(n)" performance level. I.e. the algorithm
		work (effort) should increase linearly relative to growth of
		structure size. For "O(n)", we answer "n" as shown below
		in this method (completed for you) */
		return "n";
	}

	public String first_BigO() {
		return "YOURANSWER";
	}

	public String last_BigO() {
		return "YOURANSWER";
	}

	public String find_BigO() {
		//Hint: this is a linear search
		return "YOURANSWER";
	}

	//--------------------- Adding ---------------------

	public String addFirst_BigO() {
		return "YOURANSWER";
	}

	public String addLast_BigO() {
		return "YOURANSWER";
	}

	public String add_BigO() {
		return "YOURANSWER";
	}

	public String insert_BigO() {
		return "YOURANSWER";
	}

	//--------------------- Removing ---------------------

	public String removeFirst_BigO() {
		return "YOURANSWER";
	}

	public String removeLast_BigO() {
		return "YOURANSWER";
	}

	public String removeAll_BigO() {
		return "YOURANSWER";
	}

	public String removeIndex_BigO() {
		return "YOURANSWER";
	}

	public String remove_BigO() {
		return "YOURANSWER";
	}

	//--------------------- Convenience ---------------------

	public String toJavaList_BigO() {
		return "YOURANSWER";
	}

}
